diff --git a/x86/unittests.cfg b/x86/unittests.cfg
index ad54126..4d46789 100644
--- a/x86/unittests.cfg
+++ b/x86/unittests.cfg
@@ -236,258 +236,6 @@ extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append "ept_access*"
 arch = x86_64
 groups = vmx
 
-[vmx_null]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append null
-arch = x86_64
-groups = vmx
-
-[vmx_test_vmx_feature_control]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append test_vmx_feature_control
-arch = x86_64
-groups = vmx
-
-[vmx_test_vmxon]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append test_vmxon
-arch = x86_64
-groups = vmx
-
-[vmx_test_vmptrld]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append test_vmptrld
-arch = x86_64
-groups = vmx
-
-[vmx_test_vmclear]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append test_vmclear
-arch = x86_64
-groups = vmx
-
-[vmx_test_vmptrst]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append test_vmptrst
-arch = x86_64
-groups = vmx
-
-[vmx_test_vmwrite_vmread]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append test_vmwrite_vmread
-arch = x86_64
-groups = vmx
-
-[vmx_test_vmcs_high]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append test_vmcs_high
-arch = x86_64
-groups = vmx
-
-[vmx_test_vmcs_lifecycle]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append test_vmcs_lifecycle
-arch = x86_64
-groups = vmx
-
-[vmx_test_vmx_caps]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append test_vmx_caps
-arch = x86_64
-groups = vmx
-
-[vmx_vmenter]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append vmenter
-arch = x86_64
-groups = vmx
-
-[vmx_preemption_timer]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append preemption_timer
-arch = x86_64
-groups = vmx
-
-[vmx_control_field_PAT]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append control_field_PAT
-arch = x86_64
-groups = vmx
-
-[vmx_control_field_EFER]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append control_field_EFER
-arch = x86_64
-groups = vmx
-
-[vmx_CR_shadowing]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append CR_shadowing
-arch = x86_64
-groups = vmx
-
-[vmx_IO_bitmap]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append I/O_bitmap
-arch = x86_64
-groups = vmx
-
-[vmx_instruction_intercept]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append instruction_intercept
-arch = x86_64
-groups = vmx
-
-[vmx_EPT_AD_enabled]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append EPT_A/D_enabled
-arch = x86_64
-groups = vmx
-
-[vmx_EPT_AD_disabled]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append EPT_A/D_disabled
-arch = x86_64
-groups = vmx
-
-[vmx_PML]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append PML
-arch = x86_64
-groups = vmx
-
-[vmx_VPID]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append VPID
-arch = x86_64
-groups = vmx
-
-[vmx_interrupt]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append interrupt
-arch = x86_64
-groups = vmx
-
-[vmx_debug_controls]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append debug_controls
-arch = x86_64
-groups = vmx
-
-[vmx_MSR_switch]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append MSR_switch
-arch = x86_64
-groups = vmx
-
-[vmx_vmmcall]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append vmmcall
-arch = x86_64
-groups = vmx
-
-[vmx_disable_RDTSCP]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append disable_RDTSCP
-arch = x86_64
-groups = vmx
-
-[vmx_int3]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append int3
-arch = x86_64
-groups = vmx
-
-[vmx_into]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append into
-arch = x86_64
-groups = vmx
-
-[vmx_exit_monitor_from_l2_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append exit_monitor_from_l2_test
-arch = x86_64
-groups = vmx
-
-[vmx_v2]
-file = vmx.flat
-extra_params = -cpu host,+vmx -append "v2_null_test v2_multiple_entries_test fixture_test_case1 fixture_test_case2"
-arch = x86_64
-groups = vmx
-
-[vmx_invvpid]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append invvpid_test_v2
-arch = x86_64
-groups = vmx
-
-[vmx_controls]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmx_controls_test
-arch = x86_64
-groups = vmx
-
-[vmx_vmentry_movss_shadow_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmentry_movss_shadow_test
-arch = x86_64
-groups = vmx
-
-[vmx_cr_load_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmx_cr_load_test
-arch = x86_64
-groups = vmx
-
-[vmx_nm_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmx_nm_test
-arch = x86_64
-groups = vmx
-
-[vmx_pending_event_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmx_pending_event_test
-arch = x86_64
-groups = vmx
-
-[vmx_pending_event_hlt_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmx_pending_event_hlt_test
-arch = x86_64
-groups = vmx
-
-[vmx_store_tsc_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmx_store_tsc_test
-arch = x86_64
-groups = vmx
-
-[vmx_store_tsc_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmx_store_tsc_test
-arch = x86_64
-groups = vmx
-
-[vmx_db_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmx_db_test
-arch = x86_64
-groups = vmx
-
-[vmx_nmi_window_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmx_nmi_window_test
-arch = x86_64
-groups = vmx
-
-[vmx_intr_window_test]
-file = vmx.flat
-extra_params = -cpu host,+vmx -m 2560 -append vmx_intr_window_test
-arch = x86_64
-groups = vmx
-
 [vmx_eoi_bitmap_ioapic_scan]
 file = vmx.flat
 smp = 2