diff --git a/x86/unittests.cfg b/x86/unittests.cfg
index 64ecb43..3f23cde 100644
--- a/x86/unittests.cfg
+++ b/x86/unittests.cfg
@@ -230,6 +230,12 @@ extra_params = -cpu host,+vmx -m 2560 -append -exit_monitor_from_l2_test
 arch = x86_64
 groups = vmx
 
+[ept]
+file = vmx.flat
+extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append "ept_access*"
+arch = x86_64
+groups = vmx
+
 [vmx_null]
 file = vmx.flat
 extra_params = -cpu host,+vmx -append null
@@ -410,126 +416,6 @@ extra_params = -cpu host,+vmx -append "v2_null_test v2_multiple_entries_test fix
 arch = x86_64
 groups = vmx
 
-[vmx_ept_access_test_not_present]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_not_present
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_read_only]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_read_only
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_write_only]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_write_only
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_read_write]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_read_write
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_execute_only]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_execute_only
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_read_execute]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_read_execute
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_write_execute]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_write_execute
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_read_write_execute]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_read_write_execute
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_reserved_bits]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_reserved_bits
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_ignored_bits]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_ignored_bits
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_paddr_not_present_ad_disabled]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_paddr_not_present_ad_disabled
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_paddr_not_present_ad_enabled]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_paddr_not_present_ad_enabled
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_paddr_read_only_ad_disabled]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_paddr_read_only_ad_disabled
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_paddr_read_only_ad_enabled]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_paddr_read_only_ad_enabled
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_paddr_read_write]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_paddr_read_write
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_paddr_read_write_execute]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_paddr_read_write_execute
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_paddr_read_execute_ad_disabled]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_paddr_read_execute_ad_disabled
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_paddr_read_execute_ad_enabled]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_paddr_read_execute_ad_enabled
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_paddr_not_present_page_fault]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_paddr_not_present_page_fault
-arch = x86_64
-groups = vmx
-
-[vmx_ept_access_test_force_2m_page]
-file = vmx.flat
-extra_params = -cpu host,host-phys-bits,+vmx -m 2560 -append ept_access_test_force_2m_page
-arch = x86_64
-groups = vmx
-
 [vmx_invvpid]
 file = vmx.flat
 extra_params = -cpu host,+vmx -m 2560 -append invvpid_test_v2